import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:getx_extended/export.dart';

class StatusPage extends StatelessWidget {
  TaskController _taskController = Get.find();

  @override
  Widget build(BuildContext context) => ListView(
        padding: EdgeInsets.all(24),
        children: [
          _taskController.isProcessing.toWidget((rx) => Opacity(
                opacity: rx.value ? 0.3 : 1,
                child: ElevatedButton(
                  onPressed: () {
                    _taskController.enqueue(
                      () async {
                        await Future.delayed(Duration(seconds: 3));
                      },
                    );
                  },
                  child: Text("Add loading [${_taskController.totalTasks}]"),
                ),
              )),
          ElevatedButton(
            onPressed: () {
              _taskController.catchError(DateTime.now());
            },
            child: Text("Add error "),
          ),
          TextField()
        ],
      );
}
