import 'package:get/get.dart';
import 'package:getx_extended/extension/source/async.dart';
import 'package:getx_extended/rx/source/rx_auto_startable.dart';

class RxQueryModel<Query, Result> extends Rx<Result>
    implements RxAutoStartable {
  bool isAutoStart;
  Future<Result> Function(Query query) source;
  Query query;

  RxQueryModel({
    required this.source,
    required this.query,
    required Result defaultValue,
    this.isAutoStart = true,
  }) : super(defaultValue) {
    if (isAutoStart) {
      reloadDataSource();
    }
  }

  Future reloadDataSource({
    Query? updatedQuery,
  }) async {
    if (updatedQuery != null) {
      query = updatedQuery;
    }
    isAutoStart = true;
    final data = await source(query);
    postFrameFuture(() => value = data);
    return data;
  }
}

class RxModel<T> extends RxQueryModel<void, T> {
  RxModel({
    required Future<T> Function() source,
    required T defaultValue,
    bool isAutoStart = true,
  }) : super(
          query: {},
          source: (_) => source(),
          defaultValue: defaultValue,
          isAutoStart: isAutoStart,
        );
}
